import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import iwork.eheap2.*;
import iwork.icrafter.uigen.*;
import iwork.icrafter.remote.*;
import iwork.icrafter.system.*;

/**
 * Servlet that calls on the icrafter for events to listen too.
 */
public class ServiceServlet extends HttpServlet {
    
    public EventHeap eh;
    public EHCallObject ehc;
    //whether the light service is offered at the time
    private boolean light;
    //whether the projector service is offered at the time
    private boolean projector;
    //default event heap of the room
    private static String event_heap = "iw-room2";
    //the name of the icrafter interface for the light controller
    private static String lightservice = 
	"iwork.icrafter.services.devices.LightController";
    //the name of the icrafter interface for the projector controller
    private static String projectorservice =
	"iwork.icrafter.services.devices.ProjectorController";
    public ServiceDiscoveryUtils service;
    //the output text of the servlet
    private PrintWriter out;

    /**
     * It returns a vxml webpage and processes the event associated 
     * with the request.
     * @param request the request that is made to the servlet to be processed
     * @param response the response to send back to the service that requested
     *                 the necessary action
     * 
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {
	response.setContentType("text/vxml");
	try {
	    out = response.getWriter();
	    //subscribes to the event heap
	    eh = new EventHeap(event_heap);
	    //subscribes to the icrafter services
	    service = new ServiceDiscoveryUtils(eh);
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
	//creates the menu of the services offered by the room
	out.println("<?xml version= \"1.0\" encoding= \"iso-8859-1\"?>");
	out.println("<!DOCTYPE vxml PUBLIC \" vxml\" \"\">");
	out.println("<vxml version=\"1.0\">");
	out.println("<menu>");
	out.println("<prompt>Please choose one of the following services");
	//tests to see if the light or projector service is offered
	try {
	    DiscoveredService[] blah = service.locateServices(lightservice);
	    if (blah == null) {
		light = false;
	    }
	    else {
		light=true;
	    }
	    DiscoveredService[] proj = 
		service.locateServices(projectorservice);
	    if (proj == null) {
		projector = false;
	    }
	    else {
		projector=true;
	    }
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
	
	if (light) {
	    out.println("lights");
	}
	if (projector) {
	    out.println("projectors");
	    out.println("butler");
	}
	out.println("exit");
	out.println("</prompt>");
	if (light) {
	    out.println("<choice next=\"http://iw-controlpanel:8080/servlet/VoiceServices?command=lights\">");
	    out.println("lights");
	    out.println("</choice>");
	}
	if (projector) {
	   	out.println("<choice next=\"http://iw-controlpanel:8080/servlet/VoiceServices?command=projectors\">");
	    	out.println("projectors");
	    	out.println("</choice>");
		out.println("<choice next=\"http://iw-controlpanel:8080/servlet/VoiceServices?command=butler\">");
	    	out.println("butler");
	    	out.println("</choice>");
	}
	out.println("<choice next=\"#exit\">");
	out.println("exit");
	out.println("</choice>");
	out.println("</menu>");
	out.println("<form id=\"exit\">");
	out.println("<block><exit/></block>");
	out.println("</form>");
	out.println("</vxml>");
    }    	    
}
